unit vrTaskConnectFrm;
{Processes Held at VR GIS
Send 1 till finished, then send..Start the next one}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  vrrRemConMessages,
  Clipbrd,  
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, Mask;

type
  TTaskInfoRecord = record
    TaskInfo:TTaskInfo;
    TaskList:TTaskList;
    TaskSList:TStringList;
    CpuSpeed:Double;
    TasksAvailable:Integer;
  end;
  TAvrTaskConnectFrm = class(TForm)
    IdTCPCommander: TIdTCPClient;
    OpenDialog1: TOpenDialog;
    Timer0: TTimer;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    NewClearBtn0: TSpeedButton;
    CommanderNameLabel: TLabel;
    CommanderPortLabel: TLabel;
    PasswordEdit0: TMaskEdit;
    Panel2: TPanel;
    OpenFileBtn0: TSpeedButton;
    OpenResultFileBtn0: TSpeedButton;
    TaskCB0: TComboBox;
    LaunchBtn0: TButton;
    PriorityTrackBar0: TTrackBar;
    ProgressBar0: TProgressBar;
    InFileNameEdit0: TEdit;
    IDataEdit0: TEdit;
    FDataEdit0: TEdit;
    ResultFileNameEdit0: TEdit;
    Panel3: TPanel;
    Label5: TLabel;
    StartLab0: TLabel;
    NumRecLab0: TLabel;
    LastRecLab0: TLabel;
    NumErrLab0: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label11: TLabel;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    CommanderIPEdit0: TEdit;
    CommanderPortEdit0: TEdit;
    MessagePanel0: TPanel;
    Panel7: TPanel;
    Label6: TLabel;
    CpuSpeedLabelAll: TLabel;
    TimerToggle0: TRadioButton;
    CpuUseLabelAll: TLabel;
    TabSheet2: TTabSheet;
    LogitBtn0: TSpeedButton;
    HelpBtn: TSpeedButton;
    AboutBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    Label7: TLabel;
    DroneSpeedLabel0: TLabel;
    ConnectLab0: TLabel;
    Label1: TLabel;
    Label8: TLabel;
    DroneUseLabel0: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitBtnClick(Sender: TObject);

    procedure HelpBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);

    procedure OpenFileBtn0Click(Sender: TObject);

    procedure NewClearBtn0Click(Sender: TObject);

    procedure LaunchBtn0Click(Sender: TObject);
    procedure LogitBtn0Click(Sender: TObject);


    procedure PasswordEdit0KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer0Timer(Sender: TObject);
    procedure TimerToggle0Click(Sender: TObject);
    procedure OpenResultFileBtn0Click(Sender: TObject);
    procedure ResultFileNameEdit0KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure CommanderPortEdit0KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CommanderIPEdit0KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CommanderPortEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure InFileNameEdit0KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    //Array of Records ?
    TaskInfo:TTaskInfo;
    TaskList:TTaskList;
    TaskSList:TStringList;
    CpuSpeed:Double;
    TasksAvailable:Integer;
    //TTaskInfoRecordArray: array of TTaskInfoRecord;
    
function GetCPUSpeed: Double;    
procedure SetTaskList0;
  public
    { Public declarations }
  end;

var
  AvrTaskConnectFrm: TAvrTaskConnectFrm;

implementation

uses vrGlobals, vraboutIndy, vrCpuUsage;


{$R *.DFM}

{Change So it uses an ARRAY of  Records
    TaskInfo:TTaskInfo;
    TaskList:TTaskList;
    TaskSList:TStringList;
    CpuSpeed:Double;
    TasksAvailable:Integer;
Each Tabsheet has 1 IP rather than a CB List
Create..Close : Get and Set the Edits from the vrTaskPort0..7
Create: SetLength the Array and Create the TaskSList
Destroy.. the reverse}
procedure TAvrTaskConnectFrm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;
procedure TAvrTaskConnectFrm.FormClose(Sender: TObject;
                            var Action: TCloseAction);
begin
  if IdTCPCommander.Connected then IdTCPCommander.Disconnect;
  vrTaskPort0 :=CommanderPortEdit0.Text;
  {vrTaskPort1 :=CommanderCombo.Items[1];
  vrTaskPort2 :=CommanderCombo.Items[2];
  vrTaskPort3 :=CommanderCombo.Items[3];
  vrTaskPort4 :=CommanderCombo.Items[4];
  vrTaskPort5 :=CommanderCombo.Items[5];
  vrTaskPort6 :=CommanderCombo.Items[6];
  vrTaskPort7 :=CommanderCombo.Items[7];}


  vrTaskIP0 :=CommanderIPEdit0.Text;
  {vrTaskIP1 :=CommanderIPCB.Items[1];
  vrTaskIP2 :=CommanderIPCB.Items[2];
  vrTaskIP3 :=CommanderIPCB.Items[3];
  vrTaskIP4 :=CommanderIPCB.Items[4];
  vrTaskIP5 :=CommanderIPCB.Items[5];
  vrTaskIP6 :=CommanderIPCB.Items[6];
  vrTaskIP7 :=CommanderIPCB.Items[7];}
  //Need 8 Passwords
  vrTaskPassword:=PasswordEdit0.Text;

  AvrTaskConnectFrmX := AvrTaskConnectFrm.left;
  AvrTaskConnectFrmY := AvrTaskConnectFrm.top;
end;
procedure TAvrTaskConnectFrm.FormDestroy(Sender: TObject);
begin
  TaskSList.Free;
end;
procedure TAvrTaskConnectFrm.FormCreate(Sender: TObject);
begin
  left := AvrTaskConnectFrmX;
  top := AvrTaskConnectFrmY;
  TaskSList := TStringList.Create;

 { CommanderIPCB.Items.clear;
  CommanderIPCB.Items.add(vrTaskIP0);
  CommanderIPCB.Items.add(vrTaskIP1);
  CommanderIPCB.Items.add(vrTaskIP2);
  CommanderIPCB.Items.add(vrTaskIP3);
  CommanderIPCB.Items.add(vrTaskIP4);
  CommanderIPCB.Items.add(vrTaskIP5);
  CommanderIPCB.Items.add(vrTaskIP6);
  CommanderIPCB.Items.add(vrTaskIP7);}
  CommanderIPEdit0.Text :=vrTaskIP0;

  {CommanderIPCB.ItemIndex := 0;}
  PasswordEdit0.Text:=vrTaskPassword;

 { CommanderCombo.Items.clear;
  CommanderCombo.Items.add(vrTaskPort0);
  CommanderCombo.Items.add(vrTaskPort1);
  CommanderCombo.Items.add(vrTaskPort2);
  CommanderCombo.Items.add(vrTaskPort3);
  CommanderCombo.Items.add(vrTaskPort4);
  CommanderCombo.Items.add(vrTaskPort5);
  CommanderCombo.Items.add(vrTaskPort6);
  CommanderCombo.Items.add(vrTaskPort7);}
  CommanderPortEdit0.Text :=vrTaskPort0;
  NewClearBtn0Click(Self);
end;
///////////////////////////////////////////////////
///////////////////////////////////////////////////
procedure TAvrTaskConnectFrm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(2000);
end;

procedure TAvrTaskConnectFrm.AboutBtnClick(Sender: TObject);
begin
  AboutIndy.showmodal;
end;

  
///////////////////////////////////////////////////
///////////////////////////////////////////////////
procedure TAvrTaskConnectFrm.NewClearBtn0Click(Sender: TObject);
begin
  //NumSendLabAll.Caption:=inttostr(0);//ALL use this

  NumRecLab0.Caption:=inttostr(0);
  PriorityTrackBar0.Position:= 3;
  ProgressBar0.Position:=0;
  TasksAvailable:=0;
  CpuSpeed:=0;
    CommanderNameLabel.Enabled := True;
    CommanderPortEdit0.Enabled := True;
    CommanderPortLabel.Enabled := True;
    CommanderIPEdit0.Enabled := True;
    PasswordEdit0.Enabled := True;
  FillChar(TaskInfo, SizeOf(TaskInfo), 0);
  TaskInfo.Msg:=C2D_MSG_WantConnection;
  TaskInfo.Password := PasswordEdit0.Text;
  TaskInfo.Name :='';{20 chars}
  TaskInfo.DroneIP:='';{15 chars}
  TaskInfo.DronePort := 0;
  TaskInfo.ClientID := 0;
  TaskInfo.TaskIDn :=0;
  TaskInfo.TaskAvailable:=0;
  TaskInfo.TaskData1:=0;
  TaskInfo.TaskData2:=0;
  TaskInfo.TaskResult:=0;
  TaskInfo.StartTime := now;
  TaskInfo.FinishTime := now;
  TaskInfo.Info := TaskCB0.Items[0];
  TaskInfo.InName := InFileNameEdit0.Text;
  TaskInfo.OutName := ResultFileNameEdit0.Text;
  TaskInfo.ProgressID:=0;
  TaskInfo.StatusID:=0;
  TaskInfo.PriorityID:=3;
  TaskInfo.ErrorID:=0;
  TaskInfo.ErrorInfo :='';{15 chars}
  TaskCB0.Clear;    {25 chars max}
  TaskCB0.Items.Add('Connect');
  TaskCB0.Itemindex:=0;
  TaskSList.Clear;
end;
///////////////////////////////////////////////////
///////////////////////////////////////////////////

///////////////////////////////////////////////////
///////////////////////////////////////////////////
procedure TAvrTaskConnectFrm.CommanderPortEdit1KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then CommanderPortEdit0.PasteFromClipboard
  else  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then CommanderPortEdit0.CopyToClipboard
end;


procedure TAvrTaskConnectFrm.CommanderIPEdit0KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then CommanderIPEdit0.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then CommanderIPEdit0.CopyToClipboard;
end;
procedure TAvrTaskConnectFrm.CommanderPortEdit0KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then CommanderPortEdit0.PasteFromClipboard
  else  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then CommanderPortEdit0.CopyToClipboard
end;
procedure TAvrTaskConnectFrm.PasswordEdit0KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then PasswordEdit0.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then PasswordEdit0.CopyToClipboard;
end;

procedure TAvrTaskConnectFrm.InFileNameEdit0KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then InFileNameEdit0.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then InFileNameEdit0.CopyToClipboard;
end;
procedure TAvrTaskConnectFrm.ResultFileNameEdit0KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then ResultFileNameEdit0.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then ResultFileNameEdit0.CopyToClipboard;
end;
procedure TAvrTaskConnectFrm.LogitBtn0Click(Sender: TObject);
var LogFile: File of TTaskInfo;
begin   //Extractfilepath(Application.exename);
    If FileExists(InFileNameEdit0.text) then
    begin
      AssignFile(LogFile ,
      ChangeFileExt(Application.exename,'.log'));
     // ChangeFileExt(InFileNameEdit0.text,'.log'));
      Rewrite(LogFile);
      Write(LogFile,TaskInfo);
      CloseFile(LogFile);
    end;
end;
///////////////////////////////////////////////////
///////////////////////////////////////////////////



///////////////////////////////////////////////////
///////////////////////////////////////////////////
procedure TAvrTaskConnectFrm.OpenFileBtn0Click(Sender: TObject);
begin
  OpenDialog1.InitialDir:=VRGISPath;
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    InFileNameEdit0.Text:= OpenDialog1.FileName;
  end;
end;

procedure TAvrTaskConnectFrm.OpenResultFileBtn0Click(Sender: TObject);
begin
  OpenDialog1.InitialDir:=VRGISPath;
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    ResultFileNameEdit0.Text:= OpenDialog1.FileName;
  end;
end;

procedure TAvrTaskConnectFrm.SetTaskList0;
var i:Integer;
begin
  TaskCB0.Clear;    {25 chars max}  {TaskList.Clear;}
//  TaskCB0.Items.Add('Initialize');
  TaskCB0.Items.Add('Connect');
  TaskCB0.Items.Add('Cancel + Disconnect');
  TaskCB0.Items.Add('Check Task Progress');
  TaskCB0.Items.Add('Change Task Priority');
  TaskCB0.Items.Add('Cancel Task');
  TaskCB0.Items.Add('Check Drone CPU Use');
//  TaskCB.Items.Add('Process Script File');
  For i:=0 to TasksAvailable-1 do
      TaskCB0.Items.Add(TaskSList[i]);
  TaskCB0.ItemIndex:=0;
end;




procedure TAvrTaskConnectFrm.Timer0Timer(Sender: TObject);
var i: Integer;
begin
    CollectCPUData; // Get the data for all processors
    for i:=0 to GetCPUCount-1 do // Show data for each processor
        CpuUseLabelAll.Caption:=Format('CPU #%d - %5.2f%%',[i,GetCPUUsage(i)*100]);
end;
procedure TAvrTaskConnectFrm.TimerToggle0Click(Sender: TObject);
begin
  TimerToggle0.Checked:= (not TimerToggle0.Checked);
  Timer0.Enabled:=TimerToggle0.Checked;
  If Timer0.Enabled then
  begin
   { Check Cpu use every ___ }
  end else
  begin
    CpuUseLabelAll.Caption:='<Not Set>';
  end;
end;
function TAvrTaskConnectFrm.GetCPUSpeed: Double;
const
  DelayTime = 500; // measure time in ms
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);
  Result := TimerLo / (1000.0 * DelayTime);
end;

procedure TAvrTaskConnectFrm.LaunchBtn0Click(Sender: TObject);
var
  {S,}Changling, WorkString:String;
  I:Integer;
begin   //10061
  {Send message and upon reply CREATE a Tabsheet for the Task}
  {Or just make this a 1 trick pony...
   Leave Multiple Drones to Viewer}
  If TaskCB0.ItemIndex= -1 then showmessage('select Connect');
  If TaskCB0.ItemIndex=0 then
  begin
    For I:= 1 to 3 do
    begin
      CpuSpeedLabelAll.Caption := Format('%f MHz', [GetCPUSpeed]);
      Application.ProcessMessages;
    end;
    Application.ProcessMessages;
    TaskInfo.Msg:=//C2D_MSG_FirstConnect;
                  C2D_MSG_WantConnection;
    TaskInfo.Password := PasswordEdit0.Text;
    with IdTCPCommander do
    begin
      {169.254.126.198:9999
       127.0.0.1:9999
       169.254.126.198:2345}
      {procedure TIdIOHandlerSocket.ConnectClient(
       const AHost: string;    const APort: Integer;
       const ABoundIP: string; const ABoundPort,
       ABoundPortMin, ABoundPortMax: Integer; const ATimeout: Integer = IdTimeoutDefault);}

      IdTCPCommander.Host:=CommanderIPEdit0.Text;{EHostname.Text;}
      IdTCPCommander.Port:=StrToInt(CommanderPortEdit0.Text);
      try
        IdTCPCommander.Connect{(3000)};
      except
        ConnectLab0.Caption:= 'Connect FAILED';
        Exit;//Halt;
      end;
      WriteBuffer(TaskInfo,SizeOf(TaskInfo),true);
      ConnectLab0.Caption:= IdTCPCommander.Socket.Binding.PeerIP;
      ReadBuffer(TaskInfo,SizeOf(TaskInfo));

      {CpuSpeed:=TaskInfo.FinishTime-TaskInfo.StartTime;}
      DroneSpeedLabel0.Caption:=FloatToStr(TaskInfo.FinishTime);
       //    ProgramRG.ItemIndex:=TaskInfo.ClientID;
       {Set by Drone}
      TasksAvailable:=TaskInfo.TaskAvailable;
      ConnectLab0.Caption:=TaskInfo.DroneIP
                          + ' on ' + inttostr(TaskInfo.DronePort);
      ProgressBar0.Position:=0;//TasksAvailable;
      Application.ProcessMessages;
      TaskSList.Clear;
      for i:=0 to  TasksAvailable-1 do
      begin
      ReadBuffer(TaskList,SizeOf(TaskList));
      TaskSList.Add(TaskList.Info0);
      end;
      SetTaskList0;
      //Showmessage('TC: '+TaskList.Info0);
      Disconnect;
    end; {with IdTCPCommander do}
    {We got the stuff.. now what to do what to do}
    MessagePanel0.Caption :='Connection established';
    NumRecLab0.Caption:=(inttostr(TaskInfo.Msg));
    CommanderPortEdit0.Enabled := False;
    CommanderPortLabel.Enabled := False;
    CommanderIPEdit0.Enabled := False;
    CommanderNameLabel.Enabled := False;
    PasswordEdit0.Enabled := False;
    Application.ProcessMessages;
  end {TaskCB.ItemIndex=0} else
  Begin
    Case TaskCB0.ItemIndex of
     // 1:TaskInfo.Msg:=  C2D_MSG_WantConnection;
      1:TaskInfo.Msg:=  C2D_MSG_WantDisconnection;
      2:TaskInfo.Msg:=  C2D_MSG_WantProgress;
      3:
      begin
        TaskInfo.Msg:=  C2D_MSG_Priority;
        TaskInfo.PriorityID :=PriorityTrackBar0.Position;
      end;
      4:TaskInfo.Msg:=  C2D_MSG_Cancel;
      5:TaskInfo.Msg:=  C2D_MSG_WantUsage;
      //6:TaskInfo.Msg:=  C2D_MSG_Script; D2C_MSG_Script
      (*Just Send the file name.. If it has a Script Task in the list
      Begin
        {Change this to be ~ like 0 so it SENDS  THE SCRIPT as a bunch
         of Writeln to the server!}
        TaskInfo.Msg:=C2S_MSG_Task;{Scripts}
        TaskInfo.Password := PasswordEdit.Text;
        TaskInfo.Name :=CommanderIP.Text+':'+CommanderCombo.Text;
        TaskInfo.ClientID := 0;//ProgramRG.ItemIndex;    {? known}
        TaskInfo.TaskID := TaskCB.ItemIndex;{4;}
        TaskInfo.TaskType := TaskCB.ItemIndex;  {???}
        TaskInfo.TaskData1 := strtoint(Edit1.Text);
        TaskInfo.TaskData2 := strtofloat(Edit2.Text);
        TaskInfo.TaskResult := TaskCB.ItemIndex;
        TaskInfo.StartTime := now;
        TaskInfo.FinishTime := now;
        TaskInfo.Info := TaskCB.Items[TaskCB.ItemIndex];{? known}
        TaskInfo.InName := FileNameEdit.Text;
        TaskInfo.OutName := FileNameEdit.Text;
        TaskInfo.ProgressID :=0;
        TaskInfo.StatusID :=0;
        TaskInfo.PriorityID :=PriorityTrackBar.Position;
        TaskInfo.ErrorID  := 0;
        TaskInfo.ErrorInfo := '';
      end  *)
      else
      begin   {It MUST be a TASK xx.xx.xx.name}
        WorkString:=TaskCB0.Items[TaskCB0.ItemIndex];
        {Get the first 2 xx}
        //showmessage(WorkString);
        Changling:=Copy(WorkString,0,pos('.',WorkString)-1 );
        //showmessage(Changling); //30
        TaskInfo.ClientID :=strtoint(Changling);
        {Delete the first xx.xx. the middlexx is Task count}
        Changling:=Copy(WorkString,6,Length(WorkString) );
        //showmessage(Changling);
        //Changling:=Copy(WorkString,7,pos('.',WorkString)+1 );
        WorkString:= Changling; {yyyyyyxx.name}
        {Get the xx from yyyyyyxx.name TaskAvailable}
        Changling:=Copy(WorkString,0,pos('.',WorkString)-1 );
        //showmessage(Changling);
        TaskInfo.TaskIDn :=strtoint(Changling);
        {Get the name}
        Changling:=Copy(WorkString,pos('.',WorkString)+1,Length(WorkString) );
        //showmessage(Changling);
        TaskInfo.Name := Changling;
        TaskInfo.Msg:=C2D_MSG_Task;
        {Filled from string}
        TaskInfo.TaskData1 := strtoint(IDataEdit0.Text);
        TaskInfo.TaskData2 := strtofloat(FDataEdit0.Text);
        TaskInfo.TaskResult := 0;//TaskCB.ItemIndex;//? fill
        //Should be already Set
        TaskInfo.StartTime := now;
        TaskInfo.FinishTime := now;
        TaskInfo.Info := TaskCB0.Items[TaskCB0.ItemIndex];{? known}
        TaskInfo.InName := InFileNameEdit0.Text;
        TaskInfo.OutName := ResultFileNameEdit0.Text;
        TaskInfo.ProgressID :=0;
        TaskInfo.StatusID :=0;
        TaskInfo.PriorityID :=PriorityTrackBar0.Position;
        TaskInfo.ErrorID  := 0;
        TaskInfo.ErrorInfo := '';
      end;
    End;{Case}

    with IdTCPCommander do
    begin               {169.254.126.198:9999        127.0.0.1:9999
          169.254.126.198:2345}
      IdTCPCommander.Host:=CommanderIPEdit0.Text;{EHostname.Text;}
      IdTCPCommander.Port:=StrToInt(CommanderPortEdit0.Text);
    try
      IdTCPCommander.Connect{(3000)};
    except
      on E: Exception do
      begin
      MessageDlg ('Error while connecting:'+#13+E.Message, mtError, [mbOk], 0);
      {Launch Help File with Error Code as Page Index}
      Case E.HelpContext of
      10000..100000:   Application.HelpContext(E.HelpContext);
      else   Application.HelpContext(10000);
      end;
      end;
    end;
      WriteBuffer(TaskInfo,SizeOf(TaskInfo),true);
      ConnectLab0.Caption:= IdTCPCommander.Socket.Binding.PeerIP;
      ReadBuffer(TaskInfo,SizeOf(TaskInfo));
      Disconnect;
    end;

    {Message Sent and NOW Received }
    NumRecLab0.Caption:=('ok '+inttostr(TaskInfo.Msg));
    Application.ProcessMessages;
    Case TaskInfo.Msg of
      D2C_MSG_AccountValid :
      begin
        {Dunno, it better be.. THESE NOT CHECKED HERE....}
      end ;
      D2C_MSG_AccountInvalid  : begin
                                MessagePanel0.Caption := 'server: account does not exists';
                                //Gracefully disconnected...catch by OnException on serverside;
                                //now we always disconnect anyway...
                                {IdTCPClient1.Disconnect;}
                              end;
      D2C_MSG_Connected    :
      begin
        MessagePanel0.Caption :='Connection established';
        {TaskInfo.FinishTime:= GetCPUSpeed;}
        DroneSpeedLabel0.Caption:=Floattostr(TaskInfo.FinishTime);
      end;
      D2C_MSG_DisConnected :
      begin
        ConnectLab0.Caption := 'connected with nothing';
        MessagePanel0.Caption :='Connection DisConnected';
        NewClearBtn0.Click;
      end ;
      D2C_MSG_Task :
      begin
        CommanderNameLabel.Enabled := False;
        CommanderPortEdit0.Enabled := False;
        CommanderPortLabel.Enabled := False;
        CommanderIPEdit0.Enabled := False;
        PasswordEdit0.Enabled := False;
        StartLab0.Caption:=DateTimeToStr(TaskInfo.StartTime);
        LastRecLab0.Caption:= DateTimeToStr(Now);
        NumErrLab0.Caption:=inttostr(0);
        ProgressBar0.Position:= TaskInfo.ProgressID;
        PriorityTrackBar0.Position:= TaskInfo.PriorityID;
        MessagePanel0.Caption :=TaskInfo.Name;
      end ;
      D2C_MSG_Progress :
      begin
        LastRecLab0.Caption:= DateTimeToStr(Now);
        ProgressBar0.Position:= TaskInfo.ProgressID;
        PriorityTrackBar0.Position:= TaskInfo.PriorityID;
        //If Finished Drone should have sent back
        //D2C_MSG_Finished or D2C_MSG_Error
      end ;
      D2C_MSG_Finished :
      begin
        LastRecLab0.Caption:= DateTimeToStr(TaskInfo.FinishTime);
        MessagePanel0.Caption :='Finished: '+DateTimeToStr(TaskInfo.FinishTime);
        ProgressBar0.Position:=0;
        {Set results of var data passed}

      end;
      D2C_MSG_Error :
      begin
        NumErrLab0.Caption:=Inttostr(TaskInfo.ErrorID);
        MessagePanel0.Caption :=TaskInfo.ErrorInfo;
      end ;
      D2C_MSG_Priority    :
      begin
         ProgressBar0.Position:=TaskInfo.ProgressID;
         PriorityTrackBar0.Position:= TaskInfo.PriorityID;
         LastRecLab0.Caption:= DateTimeToStr(Now);
      end;
      D2C_MSG_Cancel    :
      begin
         ProgressBar0.Position:=0;
         LastRecLab0.Caption:= DateTimeToStr(Now);
         MessagePanel0.Caption :='Task Cancelled'
      end;
      D2C_MSG_WantUsage    :
      begin
        DroneUseLabel0.Caption:=Floattostr(TaskInfo.TaskData2);
      end;
    end;{case}
  End;{Tasks}
End;
///////////////////////////////////////////////////
///////////////////////////////////////////////////







end.
